/**
 * create by xuqiangwei
 *  公文收发文登记薄公共方法
 */


var _queryObject = [];//查询条件
var _queryType = "";//查询类型， 单个查询和组合查询
var compQueryParam = null;//组合查询结果
var _dataGrid = null;//Grid 对象
var _searchObj = null;//查询框对象

/**
 * 组合查询设置
 * params = {width:宽度, height:高度, listType:列表标识, datatablId:数据表格ID}
 */
function _initCompQuery(params){
    
    if(fromListType == "section"){//栏目查看的情况不初始化高级查询
        $("#combinedQuery").hide();
        return;
    }
    
    var dialogHeight = params.height;
    var dialogWidth = params.width;
    var url = _ctxPath + '/edocStat.do?method=statCompQuery&listType=' + params.listType;
    var datatablId = params.datatablId;
    
    $("#combinedQuery").click(function(){
        window.compDialog = $.dialog({
            id: 'compDialogID',
            url: url,
            width: dialogWidth,
            height: dialogHeight,
            title: $.i18n('edoc.label.advancedSearch'),//高级查询
            transParams:{"parentWin":window},
            targetWindow:getCtpTop(),
            closeParam:{
                'show':true,
                autoClose:false,
                handler:function(){
                    compDialog.close();
                }
            },
            buttons: [{
                id : "okButton",
                text: $.i18n("edoc.query.label"),
                handler: function () {
                    var retValue = compDialog.getReturnValue();
                    if(retValue){
                        
                        if(retValue["status"] == true){
                            compDialog.close();
                            window.compQueryParam = retValue["conditions"];
                            _queryObject = window.compQueryParam;
                            
                            //高级查询
                            var o = new Object();
                            o.condition = "compQuery";
                            _queryType = "compQuery";
                            for(var i = 0; i < compQueryParam.length; i++){
                                var tempCondition = compQueryParam[i];
                                
                                var sItemType = tempCondition["type"];
                                var sItemCondition = tempCondition["condition"];
                                var sItemValue = tempCondition["value"];
                                
                                if("datemulti" == sItemType && sItemValue){//
                                    sItemValue = sItemValue[0] + "," + sItemValue[1];
                                }
                                
                              o[sItemCondition] = sItemValue;
                            }
                            _searchObj.g.clearCondition();//清空下查询查询数据
                            
                            $("#" + datatablId).ajaxgridLoad(o);
                            
                        }else{//验证错误
                            if(retValue["errMsg"]){
                                $.alert(retValue["errMsg"]);
                            }
                        }
                    }else{
                        window.compQueryParam = null; 
                    }
                }
             }, {
                 id:"cancelButton",
                 text: $.i18n("common.button.cancel.label"),
                 handler: function () {
                     compDialog.close();
                 }
            }]
        });  
    });
}

/**
 * 渲染
 * @param text
 * @param row
 * @param rowIndex
 * @param colIndex
 * @param col
 * @returns
 */
function render(text, row, rowIndex, colIndex, col) {
    
    if(text){
        if(col.dataType == "date" && col.name != "recTime"){//dataType是自己加的，标记数据类型
            text = text.substring(0, 10);
        }
    }
    
    if(col.name == 'subject' && (row.hasAttsFlag == true)){
        text += "<span class='ico16 affix_16'></span>";
    }
    
    return text
}

/**
 * 双击事件
 * @param row
 * @param colIndex
 * @param rowIndex
 */
function dbClickRow(row, colIndex, rowIndex){
    
}

/**
 * 显示和影藏列时修改colModel
 * @param cid
 * @param visible
 */
function _toggleCol(cid, visible){
    
    //这个事件传出的参数有问题
}

/**
 * 获取当前页面显示的列
 */
function _findShowColumn(){

    var showColumns = [];
    $("th", _dataGrid.grid.hDiv).each(function(){
        
        var hideFlag = true;
        var $this = $(this);
        if($this.is(":visible") == true){
            hideFlag = false;
        }else {
            hideFlag = true;
        }
        
        //改变columnmodel的值
        for(var i = 0; i < _dataGrid.p.colModel.length; i++){
            var model = _dataGrid.p.colModel[i];
            if($this.attr("colmode") == model["name"]){
                model["hide"] = hideFlag;
                if(!hideFlag){
                    showColumns.push(model);
                }
            }
        }
    });
    return showColumns;
}

//将显示列导出到数组中，用于导出
function _getCollModel(){
    var allColumns = [];
    for(var i = 0; i < _dataGrid.p.colModel.length; i++){
        var model = _dataGrid.p.colModel[i];
        allColumns.push(model);
    }
    return allColumns;
}

/**
 * 加载列表
 * @param params = {colModels:列数组，datatablId:数据表格ID, clickFn:单击时间事件方法, 
 * ajaxMethod:后台Ajax方法,customId:grid的个性化ID，}
 */
function _initGrid(params) {

    var colModels = params.colModels;
    var datatablId = params.datatablId;
    var clickFn = params.clickFn;
    var ajaxMethod = params.ajaxMethod;
    var customId = params.customId;
    
    var showCustomize = true;//是否加载用户个性化定义
    var _showToggleBtn = true;//选择列的按钮是否显示
    var disPlayColModels = [];
    if(fromListType == "section"){//栏目查看的情况不初始化工具栏
        customId = "";
        showCustomize = false;
        _showToggleBtn = false;
        
        var showColumnArray = showColumn.split(",");
        for(var i = 0; i < showColumnArray.length; i++){
            var tempColumnName = showColumnArray[i];
            for(var k = 0; k < colModels.length; k++){
                var tempModel = colModels[k];
                if(tempColumnName == tempModel["name"]){
                    tempModel["hide"] = false;
                    disPlayColModels.push(tempModel);
                }
            }
        }
        
    }else{
        disPlayColModels = colModels;
    }
    
    _dataGrid = $("#" + datatablId).ajaxgrid({
        click : clickFn,
        dblclick : dbClickRow,//还没用
        onToggleCol:_toggleCol,
        render : render,
        isHaveIframe : false,
        colModel : disPlayColModels,
        usepager : true,
        showTableToggleBtn : false,
        parentId : $('.layout_center').eq(0).attr('id'),
        vChange : false,
        vChangeParam : {
            overflow : "hidden",
            autoResize : true
        },
        managerName : "edocManager",
        managerMethod : ajaxMethod,
        slideToggleBtn : false,
        showToggleBtn : _showToggleBtn,
        resizable : false,
        customize : showCustomize,
        customId : customId
    });
    
    
    //数据初始化加载
    var o = new Object();
    if(fromListType == "section" && initCondition){//栏目查看的情况不初始化工具栏
        o.dataRight = dataRight;//查看数据的权限
        for(var key in initCondition){
            o[key] = initCondition[key];
        }
        $("#" + datatablId).ajaxgridLoad(o);
    }
}

/**
 * toolbar初始化
 * @param params = {toolbarId:HTML ID,listType:列表标识}
 */
function _initToolbar(params) {

    if(fromListType == "section"){//栏目查看的情况不初始化工具栏
        return;
    }
    
    var toolbarId = params.toolbarId;
    var listType = params.listType;
    
    $("#" + toolbarId).toolbar({
        isPager : false,
        toolbar : [ {
            id : "exportExcelMenu",
            name : $.i18n('edoc.tbar.export.js'),// 导出Excel
            className : "ico16 export_excel_16",
            click : function() {
                
                var url = _ctxPath + '/edocController.do?method=registerExport2Excel&listType=' + listType;
                _doAjaxSubmitClomnAndQuery(url, function(data){
                    //回调函数...
                });
            }
        }]
    });
}


/**
* Ajax方式提交列和查询字段
* @param url 提交地址
* @param extendParam 扩展数据， 随queryDomain域提交，注意不要重名了
* @param callbackFn 回调函数
*/
function _doAjaxSubmitClomnAndQuery(url, callbackFn, extendParam){
   
   if(url){
       
       var $columnDomain = $("#columnDomain");
       var $queryDomain = $("#queryDomain");
       
       $columnDomain.html("");
       $queryDomain.html("");
       
       //截取枚举的正则
       var codecfgRegex = /codeId[ ]*?:[ ]*?(["'])([^ ]+?)[ ]*?\1/i;
       var showColumns = _getCollModel();
       for(var i = 0; i < showColumns.length; i++){
           
           var model = showColumns[i];
           
           //拼接列form
           $columnDomain.append('<input name="display" id="display" value="'+model["display"]+'" />');
           $columnDomain.append('<input name="name" id="name" value="'+model["name"]+'" />');
           //枚举配置ID
           var codeId = "";
           if(model["codecfg"]){
               var tempCodecfg = model["codecfg"];
               var ret = codecfgRegex.exec(tempCodecfg);
               if(ret){
                   codeId = ret[2];
               }
           }
           $columnDomain.append('<input name="codecfg" id="codecfg" value="'+codeId+'" />');
       }
       if(_queryObject){
           $queryDomain.append('<input name="condition" id="condition" value="'+_queryType+'" />');
           for(var i = 0; i < _queryObject.length; i++){
               //查询条件处理
               
               var tempCondition = _queryObject[i];
               
               var sItemType = tempCondition["type"];
               var sItemCondition = tempCondition["condition"];
               var sItemValue = tempCondition["value"];
               
               if("datemulti" == sItemType && sItemValue){//
                   sItemValue = sItemValue[0] + "," + sItemValue[1];
               }
               
               $queryDomain.append('<input name="'+sItemCondition+'" id="'+sItemCondition+'" value="'+escapeStringToHTML(sItemValue)+'" />');
           }
       }
       
       //扩展参数拼接
       if(extendParam){
           for(var key in extendParam){
               $queryDomain.append('<input name="'+key+'" id="'+key+'" value="'+escapeStringToHTML(extendParam[key])+'" />');
           }
       }
       
       //提交
       var domains = ["columnDomain", "queryDomain"];
       $("#dynamicForm").jsonSubmit({
           domains : domains,
           debug : false,
           action:url,
           callback: function(data) {
               
               if(typeof(callbackFn) == "function"){
                   callbackFn(data);
               }
               
               //清空数据
               $columnDomain.html("");
               $queryDomain.html("");
           }
       });
   }
}


/**
 * 初始化查询框
 * @param params={conditionsCol:查询列,datatablId:数据表格ID}
 */
function _initSearchObj(params) {
    
    if(fromListType == "section"){//栏目查看的情况不初始化搜索框
        return;
    }
    
    var topSearchSize = 7;
    if ($.browser.msie && $.browser.version == '6.0') {
        topSearchSize = 10;
    }
    
    var rightSearchSize = $("#combinedQuery").outerWidth() + 15 + 6;
    
    var conditionsCol = params.conditionsCol;
    var datatablId = params.datatablId;
    
    _searchObj = $.searchCondition({
        top : topSearchSize,
        right : rightSearchSize,
        onchange : function() {
            // TODO
        },
        searchHandler : function() {
            var sRet = _searchObj.g.getReturnValue();
            if(sRet){
                var sItemType = sRet["type"];
                var sItemCondition = sRet["condition"];
                var sItemValue = sRet["value"];
                
                if("datemulti" == sItemType && sItemValue){//
                    sItemValue = sItemValue[0] + "," + sItemValue[1];
                }
                
                _queryObject = [];
                _queryObject.push(sRet);
                
              //数据查询
              var o = new Object();
              o.condition = sItemCondition;
              _queryType = sItemCondition;
              o[sItemCondition] = sItemValue;
              $("#" + datatablId).ajaxgridLoad(o);
            }
        },
        conditions : conditionsCol
    });

    // 默认选中标题查询条件
    _searchObj.g.setCondition('subject', '');
    _queryType = 'subject';
}

/**
 * 弹出框, 这个方法可以的话可以升级成组件
 * @param config = {title:dialog的标题，callbackFn:点确认后回调方法，msg:input上的提示语句，initValue:初始化值}
 */
function doPrompt(config){
    
    var title = config.title || " ";
    var callbackFn = config.callbackFn;
    var msg = config.msg;
    var initValue = config.initValue;
    
    var promptPageParams = {
            initValue : initValue,
            msg : msg
    }
    
    var prompWin = $.dialog({
        
        url: _ctxPath + '/edocController.do?method=showPromptPage',
        width: 360,
        height: 148,
        title: title,//
        transParams : promptPageParams,
        targetWindow:getCtpTop(),
        closeParam:{
            'show':true,
            autoClose:false,
            handler:function(){
            	try {
            		setTimeout(prompWin.close(), 5);
            	} catch(e) { }
            }
        },
        buttons: [{
            id : "okButton",
            text: $.i18n("common.button.ok.label"),
            handler: function () {
                if(callbackFn){
                    var retValue = prompWin.getReturnValue();
                    callbackFn(retValue);
                }else{
                	try {
                		setTimeout(prompWin.close(), 5);
                	} catch(e) { }
                }
            }
         }, {
             id:"cancelButton",
             text: $.i18n("common.button.cancel.label"),
             handler: function () {
            	 try {
            		 setTimeout(prompWin.close(),5);
            	 } catch(e) { }
             }
        }]
    }); 
    
    return prompWin;
}

function _initPage(){
    
    if(fromListType == "section"){
        
        //栏目查看的情况不, 移除工具栏
        var layout = $("#layout").layout()
        layout.setNorth(0);
    }
}