$(document).ready(function () {
	loadStyle();
	loadData();
	setGridHeight();
	window.onresize = setGridHeight;
 });
 
//加载页面数据
var grid;
function loadData() {
  //表格加载
	var models = getModels(edocType);
	var pageCustomId = "edoc_stat_result_rec_customId";
	if(edocType == "1") {
		pageCustomId = "edoc_stat_result_rec_customId";
	} else if(edocType == "0") {
		pageCustomId = "edoc_stat_result_send_customId";
	} else if(edocType=="2") {
		pageCustomId = "edoc_stat_result_sign_customId";
	}
	grid = $('#'+getStatResultDivId()).ajaxgrid({
        colModel: models,
        render : rend,
        edocType: edocType,
        managerName : "edocStatNewManager",
        managerMethod : "getEdocStatVoList",
        usepager : false,
        resizable : false,
        customize : true,
        customId : pageCustomId
    });	
	var obj = null;
	if($("#statConditionForm") && $("#statConditionForm").length>0) {
		obj = getConditionObjById();
		$("#statTitle").text($("#condition_statTitle").val());
	} else {
		obj = parent.fnGetParams();
		$("#statTitle").text($.i18n("edoc.stat.result.title", obj.startRangeTime, obj.endRangeTime));
	}
	$('#'+getStatResultDivId()).ajaxgridLoad(obj);
}


function getConditionObjById() {
	var obj = new Object();
	obj.edocType = edocType;
	obj.startRangeTime = $("#condition_startRangeTime").val();
	obj.endRangeTime = $("#condition_endRangeTime").val();
	obj.rangeIds = $("#condition_rangeIds").val();
	obj.displayType = $("#condition_displayType").val();
	obj.displayTimeType = $("#condition_displayTimeType").val();
	obj.sendTypeId  = $("#condition_sendType").val();
	obj.unitLevelId  = $("#condition_unitLevel").val();
	obj.operationType  = $("#condition_operationType").val();
	obj.operationTypeIds = $("#condition_operationTypeIds").val();
	return obj;
}

function getModels(edocType){
	var models = [];
	models.push({display: $.i18n("edoc.stat.org"), name: 'n', sortable : true, width: '39%',align:'center' });
	if(edocType == "1"){
		models.push({display: $.i18n("edoc.stat.result.list.totalEdocType1"), name: 'dAll', sortable : true, width: '10%' ,align:'center'});
	}else if(edocType == "0" || edocType == "2"){
		models.push({display: $.i18n("edoc.stat.result.list.totalEdocType0"), name: 'hAll', sortable : true, width: '10%',align:'center' });
	}
	models.push({display: $.i18n("edoc.stat.result.list.finish"), name: 'f', sortable : true, width: '10%',align:'center' });
	models.push({display: $.i18n("edoc.stat.result.list.waitFinish"), name: 'wf', sortable : true, width: '10%',align:'center' });
	models.push({display: $.i18n("edoc.stat.result.list.sent"), name: 's', sortable : true, width: '10%',align:'center' });
	models.push({display: $.i18n("edoc.stat.result.list.done"), name: 'd', sortable : true, width: '10%' ,align:'center'});
	models.push({display: $.i18n("edoc.stat.result.list.pending"), name: 'p', sortable : true, width: '10%',align:'center' });
	return models;
}

function getStatResultDivId() {
	var thisListDivId = "edocStatResultRec";
	if(edocType == "0") {
		thisListDivId = "edocStatResultSend";
	} else if(edocType == "2") {
		thisListDivId = "edocStatResultSign";
	}
	return thisListDivId;
}

function rend(txt, data, r, c, cobj) {
	if(c != 0) {
		txt = "<a href='javascript:void(0)' onClick=openStatResultDialog('"+cobj.name+"','"+data.id+"','"+data.t+"','"+data.tt+"')>" + txt + "</a>";
	}
    return txt;
}

function openStatResultDialog(cname,displayId,displayType,displayTimeType) {
	var listType = "";
	var listTitle = "";
	if(cname == "dAll") {
		listTitle = $.i18n("edoc.stat.result.list.totalEdocType1");
		listType = 1;
	} else if(cname == "hAll")  {
		listTitle = $.i18n("edoc.stat.result.list.totalEdocType0");
		listType = 1;
	} else if(cname == "f") {
		listTitle = $.i18n("edoc.stat.result.list.finish");
		listType = 2;
	} else if(cname == "wf") {
		listTitle = $.i18n("edoc.stat.result.list.waitFinish");
		listType = 3;
	} else if(cname == "s") {
		listTitle = $.i18n("edoc.stat.result.list.sent");
		listType = 4;
	} else if(cname == "d") {
		listTitle = $.i18n("edoc.stat.result.list.done");
		listType = 5;
	} else if(cname == "p") {
		listTitle = $.i18n("edoc.stat.result.list.pending");
		listType = 6;
	}
	listTitle += $.i18n("edoc.stat.result.list.title.label");
	var url = edocStatUrl + "?method=statEdocList&listType="+listType+"&edocType="+edocType+"&displayId="+displayId+"&displayType="+displayType+"&listTitle="+encodeURIComponent(listTitle)+"&displayTimeType="+displayTimeType;
	showSummayDialogByURL(url, listTitle);
}

var dialogDealColl;
function showSummayDialogByURL(url,title) {
  	var width = $(getA8Top().document).width() - 130;
  	var height = $(getA8Top().document).height() - 50;
  	dialogDealColl = $.dialog({
        url: url,
        width: width,
        height: height,
        title: title,
        id:'dialogDealColl',
        targetWindow:getCtpTop(),
        transParams: {'parentWin':window},
        closeParam: {
          'show':true,
          autoClose:false,
          handler:function(){
        	  dialogDealColl.close();
          }
        }        
    });
}

 function loadStyle() {
	//初始化布局
	 new MxtLayout({
        'id': 'layout',
        'northArea': {
            'id': 'north',
            'height': 30,
            'sprit': false,
            'border': false
        },
        'centerArea': {
            'id': 'center',
            'border': false,
            'minHeight': 20
        }
    });
}
 
function setGridHeight() {
	$("div.flexigrid").height($("#center").height()-5);
	$("div.bDiv").height($("div.flexigrid").height()-$("div.hDiv").height());
}

function statResultToExcel() {
	var o = new Object();
	if($("#statConditionForm") && $("#statConditionForm").length>0) {
		o = getConditionObjById();
	} else {
		o = parent.fnGetParams();
	}
	var _url = edocStatUrl + "?method=exportStatResult&edocType="+o.edocType
	+"&displayType="+o.displayType+"&rangeIds="+o.rangeIds
	+"&unitLevelId="+o.unitLevelId+"&sendTypeId="+o.sendTypeId+"&operationTypeIds="+o.operationTypeIds+"&operationType="+o.operationType
	+"&startRangeTime="+o.startRangeTime+"&endRangeTime="+o.endRangeTime+"&displayTimeType="+o.displayTimeType;
	_url += "&statTitle="+$("#statTitle").html()+CsrfGuard.getUrlSurffix();
	var hiddenIframeEl = document.getElementById("hiddenIframe");
	hiddenIframeEl.src = encodeURI(_url);
}

function printStatResult() {
	var html = $('#center').clone(true);
	
	//打印标题
	var titleHTML = document.getElementById("statTitle").outerHTML;
	html.prepend($(titleHTML));
	
	 $("span", html).removeAttr("onclick");
     popprint(html.html());
}

//打印 
function popprint(content) {
	var printContentBody = "";
	var cssList = new ArrayList();
	var pl = new ArrayList();
	var contentBody = content ;
	var contentBodyFrag = "" ;
	cssList.add("${path}/skin/dist/commom/skin.css");
	contentBodyFrag = new PrintFragment(printContentBody, contentBody);
	pl.add(contentBodyFrag);
	printList(pl,cssList);
}

